CON

  LEDA = 26
  LEDB = 27

OBJ

  rnd   :       "RealRandom"
  ser   :       "Parallax Serial Terminal"

VAR

  long seed
  byte ser_start

PUB high(pin)

  dira[pin]~~
  outa[pin]~~

PUB low(pin)

  dira[pin]~~
  outa[pin]~

PUB input(pin)

  dira[pin]~
  return ina[pin]

PUB pulse_usec(pin, usec) | time0, time1

  if (usec => 60 and usec < constant($7fff_ffff / 80))
    dira[pin]~~
    time0 := cnt + clkfreq / 10_000
    time1 := time0 + (clkfreq / 1_000_000) * usec
    waitcnt(time0)
    outa[pin]~~
    waitcnt(time1)
    outa[pin]~

PUB delay_msec(msec)

  waitcnt(cnt + clkfreq / 1000 * msec)

PUB freq_out(pin, frequency, duration_msec)

  frqa := frqval(frequency)
  dira[pin]~~
  ctra := %00100 << 26 | pin
  waitcnt(cnt + clkfreq / 1000 * duration_msec)
  ctra~
  outa[pin]~
  
PUB random(max_value)

  ifnot (seed)
    rnd.start
    seed := rnd.random
    rnd.stop
  else
    ?seed
  return (seed & $7fff_ffff) // max_value

PUB debug(text, value)

  ck_ser_start
  if (text)
    ser.str(text)
  ser.dec(value)
  ser.char(11)
  ser.char(13)

PUB wait_key

  ck_ser_start
  return ser.charin

PUB test_key

  ck_ser_start
  if (ser.rxcount)
    return ser.charin
  else
    return 0

PUB get_number

  ck_ser_start
  return ser.decin
  
PRI ck_ser_start

  ifnot(ser_start)
    ser.start(115200)
    ser_start~~

PRI frqval(a) : f

  repeat 32
     a <<= 1
     f <<= 1
     if a => clkfreq
        a -= clkfreq
        f++
     